#ifndef K3B_SCSICOMMAND_SOLARIS_H
#define K3B_SCSICOMMAND_SOLARIS_H

#include <inttypes.h>
#include <sys/types.h>
#include <sys/cdio.h>
#include <sys/scsi/generic/commands.h>

#include <endian.h>

#ifdef __cplusplus
extern "C" {
#endif

#define CDROM_PACKET_SIZE	12

struct request_sense
{
#if defined BIG_ENDIAN
    uint32_t valid		: 1;
    uint32_t error_code		: 7;
#elif defined LITTLE_ENDIAN
    uint32_t error_code		: 7;
    uint32_t valid		: 1;
#endif
    uint32_t segment_number	: 8;
#if defined BIG_ENDIAN
    uint32_t reserved1		: 2;
    uint32_t ili		: 1;
    uint32_t reserved2		: 1;
    uint32_t sense_key		: 4;
#elif defined LITTLE_ENDIAN
    uint32_t sense_key		: 4;
    uint32_t reserved2		: 1;
    uint32_t ili		: 1;
    uint32_t reserved1		: 2;
#endif
    uint32_t __pad0		: 8;
    uint32_t __pad1;

    uint64_t information[4];
    uint64_t add_sense_len;
    uint64_t command_info[4];
    uint64_t asc;
    uint64_t ascq;
    uint64_t fruc;
    uint64_t sks[3];
    uint64_t asb[46];
};

typedef struct cdrom_generic_command
{
    unsigned char cmd[CDROM_PACKET_SIZE];
    unsigned char* buffer;
    unsigned int buflen;
    int stat;
    struct request_sense* sense;
    unsigned char data_direction;
    int quiet;
    int timeout;
    char*	pad;
} cdrom_generic_command;

#ifdef __cplusplus
}
#endif

#endif

